(defun p+ (a b) (logand #xff (+ (uint a) (uint b))))
(defun p- (a b) (logand #xff (- (uint a) (uint b))))

(defun uint (a) (logand #xff a))
(defun sub (h1 l1 h l)
   (cond ((> l l1)(setq h (p- h 1)) (setq l (p- l l1))))
    (setq h (p- h h1)) (values  h l))
(defun add (h1 l1 h l)
  (let ((res (p+ l1 l)))
   (cond ((or (< res l) (< res l1))
	  (setq h (+ h 1))))
   (values (p+ h h1) res)))

(defun split (a) (list (uint a) (uint (ash a 8))))
(defun subt (x y) (apply sub (append (split x) (split y))))

(defun big (a b)
  (let ((tem (logior (ash (logand #xffffffff a) 32)
			(logand #xffffffff b))))
    (signed tem 64)))

(defun kclbig (a b)
  (let ((tem (logior (ash (logand #x7fffffff a) 31)
			(logand #x7fffffff b))))
    (signed tem 62)))
			
(defun bsplit (a) (list (ash a -32) (signed (logand #xffffffff a))))
(defun big-add (a b c d) (+ (big a b) (big c d)))
(defmacro combine (x)
  `(multiple-value-bind (a1 a2) ,x
			(let ((tem (+ (ash a1 8) a2)) t1)
			  (cond ((<= (setq t1 (- (ash 1 15) tem )) 0)
				 (- tem (ash 1 16)))
				(t tem)))))

(defun big-rem (a b c d) (let ((rem (mod (big a b) (big c d)))
			       (quot (truncate (big a b) (big c d))))
			   (list (list quot rem)(bsplit quot))))

(defun signed (x &optional (size 32))
  (cond ((>= x (ash 1 (- size 1)))
	 (- x (ash 1 size) ))
	(t x)))


(defun divide (y divisor n &aux (r y) (q 0) shif op)
  (sloop:sloop for iter downfrom n to 0
	 do (setq shif (ash divisor iter))
	 (cond ((>= R 0) (setq op "add")
		(setq R (- R shif))
		(setq Q (+ Q (ash 1 iter))))
	       (t(setq R (+ R shif)) (setq op "sub")
		(setq Q (- Q (ash 1 iter)))))
;	 (format t "~%~a (Q ~a ~a) (R ~a ~a) ~a" iter Q (bsplit Q) R (bsplit r)		 op)
	 (format t "~%~a ~a ~a ~a" iter (cons 'Q (bsplit Q))
		 (cons 'R (bsplit r)) op)
	       )
  (cond ((< r 0) (setq q (- q 1) r (+ r divisor))))
  (assert (eql y (+ r (* q divisor))))
  (values q r))
	

(defun di (d h l q r)
  (assert (equal (+ r (* d q)) (kclbig h l))))
